"""
    Edit Page Templates with IE Editor.
"""

import urllib
import Globals
import string

from Globals import HTMLFile
from string import find, rfind, lower, join, whitespace

from Products.PageTemplates.ZopePageTemplate import ZopePageTemplate 
from Products.PageTemplates.PageTemplateFile import PageTemplateFile

def document_body(self, REQUEST=None, RESPONSE=None):
    """Returns the documentbody."""

    if RESPONSE is not None:
        RESPONSE.setHeader('Content-Type', 'text/plain')
        
    if REQUEST is not None and REQUEST.get('raw'):
        mytext = self._text
        
    mytext = self.read()
    
    pos1 = find(mytext, '<!--BEGIN-->')
    pos2 = find(mytext, '<!--END-->')
    if pos1 > 0 and pos2 == -1:
      mytext =  mytext [pos1+13:]

    if pos1 ==-1  and pos2 > 0:
      mytext =  mytext [:pos2]

    if pos1 >0  and pos2 > 0:
      mytext =  mytext [pos1+13:pos2-1]
      
    return mytext


def manage_save(self, id='', title='', submit=None, REQUEST=None):
    """ Attempts to save the data. """
    
    self.pt_setTitle(title)
    content = REQUEST['content']
    
    pos = find(content, '<!--BEGIN-->')
    if pos == -1:
       tmp1 = '<html metal:use-macro="container/standard_template.pt/macros/page"><div metal:fill-slot="body"><!--BEGIN-->\n'
    else:
       tmp1=''

    pos = find(content, '<!--END-->')
    if pos == -1:
       tmp2 = '\n<!--END--></div></html>\n'
    else:
       tmp2=''
       
    self.write (tmp1 + REQUEST['content'] + tmp2)
    
    message = "Saved changes."

    if getattr(self, '_v_warnings', None):
        message = ("<strong>Warning:</strong> <i>%s</i>"
                       % '<br>'.join(self._v_warnings))
                       
    return self.manage_editIEForm(manage_tabs_message=message)
    
    
targets = (
    ZopePageTemplate,
)

manage_options = (
    {'label':'Edit IE', 
     'action':'manage_editIEForm',
     'help':('PatchKit', 'edit_ie.stx'),
    },
)

methods = {
    'manage_editIEForm':   PageTemplateFile('www/editIE', globals()),
    'ieeditor': HTMLFile('ieeditor/ieeditor', globals()),
    'insimage': HTMLFile('ieeditor/insimage', globals()),
    'inslink': HTMLFile('ieeditor/inslink', globals()),
    'instable': HTMLFile('ieeditor/instable', globals()),
    'selcolor': HTMLFile('ieeditor/selcolor', globals()),    
    'editor_browse_files': HTMLFile('ieeditor/editor_browse_files', globals()),
    'editor_browse_images': HTMLFile('ieeditor/editor_browse_images', globals()), 
    'manage_save': manage_save,
    'document_body': document_body,
}
